% carte de champ avec interpolation et position des tiges, ventuellement anime
%=================================================================
clear all; close all;
titre='map_c_nntig7';
fichierchamp = ['gril.',titre];
champ = dlmread(fichierchamp,'',2,0);
fichiertiges = 'rotated0.tiges';
tiges = dlmread(fichiertiges,'',1,0);

% Champ
x = unique(champ(:,1)); xmin = min(x); xmax = max(x); nx=length(x); dx = (xmax-xmin)/(nx-1);
y = unique(champ(:,2)); ymin = min(y); ymax = max(y); ny=length(y); dy = (ymax-ymin)/(ny-1);

% Position des tiges :
xc = tiges(:,2);
yc = tiges(:,3);
ray = tiges(:,9); dia = 2*ray;
nt=length(xc);

% Interpolation
modu=champ(:,5); % attention: 5 pour le module, 6 pour la phase
z=reshape(modu,ny,[]);
% Au lieu d'utiliser pcolor(x,y,z), on interpole sur un pas deux fois plus fin
[xi,yi] = meshgrid(xmin:dx/2:xmax,ymin:dy/2:ymax);
zi = interp2(x,y,z,xi,yi);

%------------------------------------------------------
% Choisir les types de cartes en fonction des besoins :
%------------------------------------------------------

%------------------------------------------------------
% Dgrads
%------------------------------------------------------
% pcolor(xi,yi,zi) % dgrads
% shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
% caxis([0 1]); colorbar;

%------------------------------------------------------
% Contour
%------------------------------------------------------
zmin = 0; zmax = 1; deltaz = 0.1; % utiliss pour lignes de niveau et colorbar
nbcouleurs = (zmax-zmin)/deltaz;
colormap(jet(nbcouleurs)); % cre une palette de couleurs restreintes
v = [zmin:deltaz:zmax]; 
[C,h] = contourf(xi,yi,zi,v); % contour avec lignes de niveau
% clabel(C,h); pour afficher les valeurs des lignes de niveau
caxis([zmin zmax]); colorbar;

axis square; 
title(titre,'Interpreter','none');

% Ajout des tiges
for it=1:nt
    rectangle('Position',[xc(it)-ray(it),yc(it)-ray(it),dia(it),dia(it)],'Curvature',[1,1],'EdgeColor','k','LineWidth',0.5)
end

%------------------------------------------------------
% Colormap allant d'une couleur  une autre:
%------------------------------------------------------
figure % draws a new figure
colormap(deuxcouleursGT(nbcouleurs))
[C,h] = contourf(xi,yi,zi,v); % contour avec lignes de niveau
caxis([zmin zmax]); colorbar;

%------------------------------------------------------
% Contour sans lignes de niveau:
%------------------------------------------------------
figure % draws a new figure
% colormap(deuxcouleursGT(40))
% colormap(deuxcouleursGT(nbcouleurs))
pcolor(xi,yi,zi) % dgrads
shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
caxis([0 1]); colorbar;

% Ajout des tiges
for it=1:nt
    rectangle('Position',[xc(it)-ray(it),yc(it)-ray(it),dia(it),dia(it)],'Curvature',[1,1],'EdgeColor','k','LineWidth',0.5)
end

axis square; 
title(titre,'Interpreter','none');

%----------------------------------------------------
% Place des tickmarks sur les 4 cots, et les met en avant-plan:
set(gca,'Box','On','Layer','top');

%----------------------------------------------------
% Exporter en fichier graphique:
% On peut le faire depuis la figure avec File / Export
% ou bien en ligne de commande:
print('-depsc2',[titre,'-epsc2']) % no apparent difference between epsc and epsc2
print('-depsc',[titre,'-epsc']) % default resolution (150 dpi)
print('-depsc','-r300',[titre,'-epsc_300']) % eps 300 dpi => 6 MB file
print('-depsc','-r600',[titre,'-epsc_600']) % eps 600 dpi => 100 MB file
print('-depsc','-r150',[titre,'-epsc_150']) % eps 150 dpi

print('-dpng',[titre,'-png']) % png default
print('-dpng','-r300',[titre,'-png_300']) % png 300 dpi

%----------------------------------------------------
% A faire:
% Mettre d'autres couleurs pour les valeurs qui dpassent les min et max (noir et magenta sur mes graphes Origin).
% Exporter en fichier graphique

% Xavier Checoury utilise cette commande pour la mise en page avant l'impression vers PNG par exemple:
%figure4 = figure('Position',[923 653 305 271],'PaperSize',[8,8.1],'PaperPosition',[0 0 8 8]);

%----------------------------------------------------
%  animation : A FAIRE
